--- old/usr/src/uts/armv6/loader/fakeloader.c	2015-02-12 20:33:37.675563581 -0500
+++ new/usr/src/uts/armv6/loader/fakeloader.c	2015-02-12 20:33:37.683028454 -0500
@@ -163,11 +163,18 @@
 	l1e = (arm_l1s_t *)pte;
 	*pte = 0;
 	l1e->al_type = ARMPT_L1_TYPE_SECT;
-	/* Assume it's not device memory */
-	l1e->al_bbit = 1;
-	l1e->al_cbit = 1;
-	l1e->al_tex = 1;
-	l1e->al_sbit = 1;
+
+	if (prot & PF_DEVICE) {
+		l1e->al_bbit = 1;
+		l1e->al_cbit = 0;
+		l1e->al_tex = 0;
+		l1e->al_sbit = 1;
+	} else {
+		l1e->al_bbit = 1;
+		l1e->al_cbit = 1;
+		l1e->al_tex = 1;
+		l1e->al_sbit = 1;
+	}
 
 	if (!(prot & PF_X))
 		l1e->al_xn = 1;
